# 关联共享资源或资源使用者文档示例

该项目为为共享单元关联共享资源或资源使用者。文档示例，该示例**无法在线调试**，如需调试可下载到本地后替换 [AK](https://usercenter.console.aliyun.com/#/manage/ak) 以及参数后进行调试。

## 运行条件

- 下载并解压需要语言的代码;

- 在阿里云帐户中获取您的 [凭证](https://usercenter.console.aliyun.com/#/manage/ak)并通过它替换下载后代码中的 ACCESS_KEY_ID 以及 ACCESS_KEY_SECRET;

- 执行对应语言的构建及运行语句

## 执行步骤
下载的代码包，在根据自己需要更改代码中的参数和 AK 以后，可以在**解压代码所在目录下**按如下的步骤执行

- Java
*JDK 版本要求 1.8*
```sh
mvn clean package
java -jar target/sample-1.0.0-jar-with-dependencies.jar
```

- TypeScript
*Node 版本要求 10.x 及以上*
```sh
npm install --registry=https://registry.npm.taobao.org && tsc && node ./dist/client.js
```

- Go
*Golang 版本要求 1.13 及以上*
```sh
GOPROXY=https://goproxy.cn,direct go run ./main
```

- PHP
*PHP 版本要求 7.2 及以上*
```sh
composer install && php src/Sample.php
```

- Python
*Python 版本要求 Python3*
```sh
python3 setup.py install && python ./alibabacloud_sample/sample.py
```

- C#
*.NETCORE 版本要求 2.1及以上*
```sh
cd ./core && dotnet run
```

## 使用的 API

-  AssociateResourceShare 为共享单元关联共享资源或资源使用者。文档示例，可以参考：[文档](https://next.api.aliyun.com/document/ResourceSharing/2020-01-10/AssociateResourceShare)



## 返回示例

*实际输出结构可能稍有不同，属于正常返回；下列输出值仅作为参考，以实际调用为准*


- JSON 格式 
```js
{
  "ResourceShareAssociations": [
    {
      "ResourceShareId": "rs-6GRmdD3X****",
      "EntityId": "vsw-bp183p93qs667muql****",
      "EntityType": "VSwitch",
      "AssociationStatusMessage": "",
      "AssociationType": "Resource",
      "CreateTime": "2020-12-04T09:40:41.246Z",
      "UpdateTime": "2020-12-04T09:40:41.246Z",
      "ResourceShareName": "test",
      "AssociationStatus": "Associating"
    },
    {
      "ResourceShareId": "rs-6GRmdD3X****",
      "EntityId": "172050525300****",
      "EntityType": "Account",
      "AssociationStatusMessage": "",
      "AssociationType": "Target",
      "CreateTime": "2020-12-04T09:40:41.250Z",
      "UpdateTime": "2020-12-04T09:40:41.250Z",
      "ResourceShareName": "test1",
      "AssociationStatus": "Associating"
    }
  ],
  "RequestId": "111FB84A-60A9-403E-9067-E55D7EE95BD1"
}
```
- XML 格式 
```xml
<?xml version="1.0" encoding="UTF-8" ?>
<AssociateResourceShareResponse>
	<ResourceShareAssociations>
		<ResourceShareId>rs-6GRmdD3X****</ResourceShareId>
		<EntityId>vsw-bp183p93qs667muql****</EntityId>
		<EntityType>VSwitch</EntityType>
		<AssociationStatusMessage></AssociationStatusMessage>
		<AssociationType>Resource</AssociationType>
		<CreateTime>2020-12-04T09:40:41.246Z</CreateTime>
		<UpdateTime>2020-12-04T09:40:41.246Z</UpdateTime>
		<ResourceShareName>test</ResourceShareName>
		<AssociationStatus>Associating</AssociationStatus>
	</ResourceShareAssociations>
	<ResourceShareAssociations>
		<ResourceShareId>rs-6GRmdD3X****</ResourceShareId>
		<EntityId>172050525300****</EntityId>
		<EntityType>Account</EntityType>
		<AssociationStatusMessage></AssociationStatusMessage>
		<AssociationType>Target</AssociationType>
		<CreateTime>2020-12-04T09:40:41.250Z</CreateTime>
		<UpdateTime>2020-12-04T09:40:41.250Z</UpdateTime>
		<ResourceShareName>test1</ResourceShareName>
		<AssociationStatus>Associating</AssociationStatus>
	</ResourceShareAssociations>
	<RequestId>111FB84A-60A9-403E-9067-E55D7EE95BD1</RequestId>
</AssociateResourceShareResponse>	

```


