// This file is auto-generated, don't edit it. Thanks.
package com.aliyun.sample;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.aliyun.resourcesharing20200110.models.AssociateResourceShareRequest;
import com.aliyun.resourcesharing20200110.models.AssociateResourceShareRequest.AssociateResourceShareRequestResources;
import com.aliyun.resourcesharing20200110.models.CreateResourceShareRequest;
import com.aliyun.resourcesharing20200110.models.CreateResourceShareRequest.CreateResourceShareRequestResources;
import com.aliyun.resourcesharing20200110.models.CreateResourceShareResponse;
import com.aliyun.resourcesharing20200110.models.ListResourceSharesRequest;
import com.aliyun.tea.TeaException;

/**
 * 本用例演示了资源所有者如何将快照资源共享给其他用户使用
 * 资源共享管理创建共享单元API参考文档：https://help.aliyun.com/document_detail/2330847.html
 * 开发者门户：https://api.aliyun.com/api/ResourceSharing/2020-01-10/CreateResourceShare
 * 相关内容仅供参考，请根据业务实际场景进行修改
 */
public class CreateResourceShare {
    private static final String RESOURCE_TYPE_SNAPSHOT = "Snapshot";

    /**
     * 使用AK&SK初始化账号Client
     *
     * @param accessKeyId
     * @param accessKeySecret
     * @return Client
     * @throws Exception
     */
    public static com.aliyun.resourcesharing20200110.Client createClient(String accessKeyId, String accessKeySecret)
        throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config()
            // 必填，您的 AccessKey ID
            .setAccessKeyId(accessKeyId)
            // 必填，您的 AccessKey Secret
            .setAccessKeySecret(accessKeySecret);
        // Endpoint 请参考 https://api.aliyun.com/product/ResourceSharing
        config.endpoint = "resourcesharing.cn-shenzhen.aliyuncs.com";
        return new com.aliyun.resourcesharing20200110.Client(config);
    }

    /**
     * 使用STS鉴权方式初始化账号Client，推荐此方式。
     *
     * @param accessKeyId
     * @param accessKeySecret
     * @param securityToken
     * @return Client
     * @throws Exception
     */
    public static com.aliyun.resourcesharing20200110.Client createClientWithSTS(String accessKeyId,
        String accessKeySecret, String securityToken) throws Exception {
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config()
            // 必填，您的 AccessKey ID
            .setAccessKeyId(accessKeyId)
            // 必填，您的 AccessKey Secret
            .setAccessKeySecret(accessKeySecret)
            // 必填，您的 Security Token
            .setSecurityToken(securityToken)
            // 必填，表明使用 STS 方式
            .setType("sts");
        // Endpoint 请参考 https://api.aliyun.com/product/ResourceSharing
        config.endpoint = "resourcesharing.cn-shenzhen.aliyuncs.com";
        return new com.aliyun.resourcesharing20200110.Client(config);
    }

    private static AssociateResourceShareRequest associateResourceShareRequest(String resourceShareId,
        Map<String, String> resouresMap, List<String> targetUid) {
        AssociateResourceShareRequest associateResourceShareRequest = new AssociateResourceShareRequest();
        associateResourceShareRequest.setResources(buildassociateResourcesList(resouresMap));
        associateResourceShareRequest.setResourceShareId(resourceShareId);
        associateResourceShareRequest.setTargets(targetUid);
        return associateResourceShareRequest;
    }

    private static List<AssociateResourceShareRequestResources> buildassociateResourcesList(
        Map<String, String> resouresMap) {
        List<AssociateResourceShareRequestResources> resourcesList = new ArrayList<>();
        if (resouresMap == null || resouresMap.isEmpty()) {
            return resourcesList;
        }
        for (Map.Entry<String, String> entry : resouresMap.entrySet()) {
            AssociateResourceShareRequestResources resource = new AssociateResourceShareRequestResources();
            resource.setResourceId(entry.getKey());
            resource.setResourceType(entry.getValue());
            resourcesList.add(resource);
        }
        return resourcesList;
    }

    private static CreateResourceShareRequest createResourceShareRequest(Map<String, String> resouresMap,
        List<String> targetUid) {

        CreateResourceShareRequest createResourceShareRequest = new CreateResourceShareRequest();
        createResourceShareRequest.setResources(buildResourcesList(resouresMap));
        createResourceShareRequest.setResourceShareName("$设置的共享单元名称$");
        createResourceShareRequest.setTargets(targetUid);
        createResourceShareRequest.setAllowExternalTargets(true);
        return createResourceShareRequest;
    }

    private static List<CreateResourceShareRequestResources> buildResourcesList(Map<String, String> resouresMap) {
        List<CreateResourceShareRequestResources> resourcesList = new ArrayList<>();
        if (resouresMap == null || resouresMap.isEmpty()) {
            return resourcesList;
        }
        for (Map.Entry<String, String> entry : resouresMap.entrySet()) {
            CreateResourceShareRequestResources resource = new CreateResourceShareRequestResources();
            resource.setResourceId(entry.getKey());
            resource.setResourceType(entry.getValue());
            resourcesList.add(resource);
        }
        return resourcesList;
    }

    public static void main(String[] args_) throws Exception {
        // 请确保代码运行环境设置了环境变量 ALIBABA_CLOUD_ACCESS_KEY_ID 和 ALIBABA_CLOUD_ACCESS_KEY_SECRET。
        // 工程代码泄露可能会导致 AccessKey 泄露，并威胁账号下所有资源的安全性。以下代码示例仅供参考，建议使用更安全的 STS 方式，更多鉴权访问方式请参见：https://help.aliyun.com/document_detail/378657.html
        com.aliyun.resourcesharing20200110.Client client = createClient(
            System.getenv("ALIBABA_CLOUD_ACCESS_KEY_ID"), System.getenv("ALIBABA_CLOUD_ACCESS_KEY_SECRET"));
        try {
            //创建共享单元
            //1.设置共享资源信息
            Map<String, String> resourceMaps = new HashMap<>();
            resourceMaps.put("$需要被共享的快照ID$", RESOURCE_TYPE_SNAPSHOT);
            //2.设置目标用户信息
            List<String> targetUid = new ArrayList<>();
            targetUid.add("$接受共享资源的用户账号UID$");
            //3.创建共享单元信息
            CreateResourceShareRequest createResourceShareRequest = createResourceShareRequest(resourceMaps, targetUid);
            CreateResourceShareResponse createResourceShareResponse = client.createResourceShare(
                createResourceShareRequest);
            com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(createResourceShareResponse));

            String resourceShareId = createResourceShareResponse.getBody().getResourceShare().getResourceShareId();

            //给共享单元追加资源
            //Map<String, String> associateResourceMaps = new HashMap<>();
            //associateResourceMaps.put("$共享单元内追加的快照ID$", RESOURCE_TYPE_SNAPSHOT);
            //AssociateResourceShareRequest associateResourceShareRequest = associateResourceShareRequest(resourceShareId,
            //    associateResourceMaps, targetUid);
            //com.aliyun.teautil.models.RuntimeOptions runtime = new com.aliyun.teautil.models.RuntimeOptions();
            //com.aliyun.resourcesharing20200110.models.AssociateResourceShareResponse associateResourceShareResponse
            //    = client.associateResourceShareWithOptions(associateResourceShareRequest, runtime);
            //com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(associateResourceShareResponse));

            //查询发起的共享单元信息
            List<String> resourceShareIds = new ArrayList<>();
            resourceShareIds.add(resourceShareId);
            ListResourceSharesRequest listResourceSharesRequest = new ListResourceSharesRequest();
            listResourceSharesRequest.setResourceShareIds(resourceShareIds);
            com.aliyun.resourcesharing20200110.models.ListResourceSharesResponse listResourceSharesResponse
                = client.listResourceShares(listResourceSharesRequest);
            com.aliyun.teaconsole.Client.log(com.aliyun.teautil.Common.toJSONString(listResourceSharesResponse));
        } catch (TeaException error) {
            // 如有需要，请打印 error
            com.aliyun.teautil.Common.assertAsString(error.message);
        } catch (Exception _error) {
            TeaException error = new TeaException(_error.getMessage(), _error);
            // 如有需要，请打印 error
            com.aliyun.teautil.Common.assertAsString(error.message);
        }
    }
}
